# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.conditioning_scale_value_array import ConditioningScaleValueArray
from typing import Optional, Set
from typing_extensions import Self

class ControlNetRequestControlNet(BaseModel):
    """
    ControlNetRequestControlNet
    """ # noqa: E501
    conditioning_scale: Optional[ConditioningScaleValueArray] = Field(default=None, alias="conditioningScale")
    guidance_start: Optional[Union[Annotated[float, Field(le=1, strict=True, ge=0)], Annotated[int, Field(le=1, strict=True, ge=0)]]] = Field(default=None, description="Percentage of inference steps at which to begin conditioning the inference with the ControlNet.", alias="guidanceStart")
    guidance_end: Optional[Union[Annotated[float, Field(le=1, strict=True, ge=0)], Annotated[int, Field(le=1, strict=True, ge=0)]]] = Field(default=None, description="Percentage of inference steps at which to stop conditioning the inference with the ControlNet.", alias="guidanceEnd")
    __properties: ClassVar[List[str]] = ["conditioningScale", "guidanceStart", "guidanceEnd"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ControlNetRequestControlNet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of conditioning_scale
        if self.conditioning_scale:
            _dict['conditioningScale'] = self.conditioning_scale.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ControlNetRequestControlNet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "conditioningScale": ConditioningScaleValueArray.from_dict(obj["conditioningScale"]) if obj.get("conditioningScale") is not None else None,
            "guidanceStart": obj.get("guidanceStart"),
            "guidanceEnd": obj.get("guidanceEnd")
        })
        return _obj


