# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class CreateCollectionRequestSynthesisRules(BaseModel):
    """
    CreateCollectionRequestSynthesisRules
    """ # noqa: E501
    no_attribution_greater_than: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="No attribution greater than x% for any Al generated music.", alias="noAttributionGreaterThan")
    no_attribution_smaller_than: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="No attribution smaller than x% if music in your style is requested.", alias="noAttributionSmallerThan")
    no_shared_attribution_with_artist: Optional[StrictStr] = Field(default=None, description="No shared attribution with artist xyz", alias="noSharedAttributionWithArtist")
    no_shared_attribution_with_genre: Optional[StrictStr] = Field(default=None, description="No shared attribution with genre xyz", alias="noSharedAttributionWithGenre")
    __properties: ClassVar[List[str]] = ["noAttributionGreaterThan", "noAttributionSmallerThan", "noSharedAttributionWithArtist", "noSharedAttributionWithGenre"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCollectionRequestSynthesisRules from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCollectionRequestSynthesisRules from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "noAttributionGreaterThan": obj.get("noAttributionGreaterThan"),
            "noAttributionSmallerThan": obj.get("noAttributionSmallerThan"),
            "noSharedAttributionWithArtist": obj.get("noSharedAttributionWithArtist"),
            "noSharedAttributionWithGenre": obj.get("noSharedAttributionWithGenre")
        })
        return _obj


