# coding: utf-8

"""
    Sureel API

    API for the Sureel network.

    The version of the OpenAPI document: 
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class FinetuningRequest(BaseModel):
    """
    FinetuningRequest
    """ # noqa: E501
    collection_uuid: StrictStr = Field(description="A collection can be any kind of release, such as an album, a single, EP, compilation, or any other mix of audio files or image files.     Each collection has a `collectionUuid`.     Every artist/label can create multiple collections of artworks.     New collections can be created with the `/artist/upload-artwork` endpoint and existing collections can be obtained with the `/artist/collections` endpoint. For the fine-tuning, the `collectionUuid` is used to condition the image captions and to associate with the training images.", alias="collectionUuid")
    num_train_steps: Annotated[int, Field(le=1300, strict=True, ge=40)] = Field(description="Number of backwards passes to perform in total for LDM fine-tuning.         We recommend to set the `numTrainSteps` parameter to 60 times the number of images in the collection with a lower limit of 300 and an upper limit of 1000.", alias="numTrainSteps")
    train_text_encoder: Optional[StrictBool] = Field(default=True, description="Whether to also train the text encoder for stronger integration of the new visual concepts.", alias="trainTextEncoder")
    learning_rate: Optional[Union[Annotated[float, Field(le=0.1, strict=True, ge=0.0000010)], Annotated[int, Field(le=0, strict=True, ge=1)]]] = Field(default=0.000050, description="How strongly the model should change per step.", alias="learningRate")
    capacity: Optional[Annotated[int, Field(le=20, strict=True, ge=1)]] = Field(default=None, description="How much capacity the model will have for learning new features.         Impacts the extent of modifications applied to a model's parameters.         The higher the capacity, the higher the training steps should be.")
    seed: Optional[Annotated[int, Field(le=2147483647, strict=True, ge=-2147483648)]] = Field(default=None, description="Seed to control randomness in the fine-tuning process and enable reproducibility.             If not specified, the fine-tuning process is random.             If the seed is fixed to the same number, the generation will always yield the same result.")
    webhook: Optional[StrictStr] = Field(default=None, description="Webhook URL where you receive notifications regarding completed requests.")
    __properties: ClassVar[List[str]] = ["collectionUuid", "numTrainSteps", "trainTextEncoder", "learningRate", "capacity", "seed", "webhook"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FinetuningRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FinetuningRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "collectionUuid": obj.get("collectionUuid"),
            "numTrainSteps": obj.get("numTrainSteps"),
            "trainTextEncoder": obj.get("trainTextEncoder") if obj.get("trainTextEncoder") is not None else True,
            "learningRate": obj.get("learningRate") if obj.get("learningRate") is not None else 0.000050,
            "capacity": obj.get("capacity"),
            "seed": obj.get("seed"),
            "webhook": obj.get("webhook")
        })
        return _obj


